# Makefile snippet included by projects using libt2n-codegen

# Asumptions: 
# gnu make (functions for transforming text)
# sed is available

include_HEADERS += $(foreach i, $(CMDGROUPS), $(i)_client.hxx $(i).hxx)

# not needed but nice to have
# IFILES=$(foreach i, $(CMDGROUPS), $(foreach j, $($(i)_GROUP), $(j)))

-include $(foreach i, $(CMDGROUPS), libt2ngroup_$(i).P)

libt2ngroup_%.P : Makefile.am
	echo $@ : $($*_GROUP) > libt2ngroup_$*.P

%.libt2nstamp : libt2ngroup_%.P
# assuming we have some unix like shell (maybe even bash)
#	echo BUILT_SOURCES: $(BUILT_SOURCES)
# temporarily create _common.hxx file (will be overwritten by codegen below)
	echo '#include "codegen-stubhead.hxx"' > $*_common.hxx;
	echo '#include "$*.hxx"' >> $*_common.hxx;
# todo use tmp file for xml file
	for i in $($*_GROUP); do \
		gccxml $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS) $(srcdir)/$${i} -fxml=$${i%*.cpp}.xml; \
	done && $(LIBT2N_CODEGEN) $* $($*_GROUP:.cpp=.xml) && for i in $($*_GROUP); do \
		rm $${i%*.cpp}.xml; \
	done && touch $@

LIBT2N_CODEGEN_BUILT = $(foreach i, $(CMDGROUPS), $(foreach j, _common.hxx _common.cpp _client.hxx _client.cpp _server.hxx _server.cpp, $(i)$(j)) )

# using BUILT_SOURCES is a bit problematic (see also automake manual)
BUILT_SOURCES += $(LIBT2N_CODEGEN_BUILT)

LIBT2N_STAMPS=$(CMDGROUPS:=.libt2nstamp)
$(BUILT_SOURCES) : $(LIBT2N_STAMPS)

# Install the pkg-config files: (todo: perhaps use +=)
pkgconfigdir = $(libdir)/pkgconfig
pkgconfig_DATA = $(CMDGROUPS:=.pc)

# .pc files (one pc file for each command group)
%.pc : $(LIBT2N_CLIENT_PCTEMPLATE) Makefile
	sed \
	-e 's,\@CMDGROUP\@,$*,g' \
	-e 's,\@prefix\@,$(prefix),g' \
	-e 's,\@exec_prefix\@,$(exec_prefix),g' \
	-e 's,\@libdir\@,$(libdir),g' \
	-e 's,\@includedir\@,$(includedir),g' \
	-e 's,\@VERSION\@,$(VERSION),g' \
	$< >$*.pc

CLEANFILES += $(LIBT2N_CODEGEN_BUILT) $(LIBT2N_STAMPS) $(pkgconfig_DATA)
DISTCLEANFILES += $(foreach i, $(CMDGROUPS), libt2ngroup_$(i).P)

# didn't work (same problem as with _LTLIBRARIES [parsing by automake],
# this time _OBJECTS was not correct)
# server_SOURCES = server.cpp \
#	$(foreach i, $(CMDGROUPS), $(foreach j, $($(i)_GROUP), $(j))) \
#	$(foreach i, $(CMDGROUPS), $(i)_server.cpp)

# we have got an old automake version (1.4-p5) which doesn't support nodist_
# => we use this hack using the dist-hook
dist-hook: $(LIBT2N_CODEGEN_BUILT)
	rm -vf $(foreach i, $(LIBT2N_CODEGEN_BUILT), $(distdir)/$(i))

EXTRA_DIST += codegen.make
